## tree-sitter-c 0.21.3

=== Makefile ===
VERSION := 0.21.3

LANGUAGE_NAME := tree-sitter-c

# repository
SRC_DIR := src

PARSER_REPO_URL := $(shell git -C $(SRC_DIR) remote get-url origin 2>/dev/null)

ifeq ($(PARSER_URL),)
	PARSER_URL := $(subst .git,,$(PARSER_REPO_URL))
ifeq ($(shell echo $(PARSER_URL) | grep '^[a-z][-+.0-9a-z]*://'),)
	PARSER_URL := $(subst :,/,$(PARSER_URL))
	PARSER_URL := $(subst git@,https://,$(PARSER_URL))
endif
endif

TS ?= tree-sitter

# ABI versioning
SONAME_MAJOR := $(word 1,$(subst ., ,$(VERSION)))
SONAME_MINOR := $(word 2,$(subst ., ,$(VERSION)))

# install directory layout
PREFIX ?= /usr/local
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
PCLIBDIR ?= $(LIBDIR)/pkgconfig

# object files
OBJS := $(patsubst %.c,%.o,$(wildcard $(SRC_DIR)/*.c))

# flags
ARFLAGS := rcs
override CFLAGS += -I$(SRC_DIR) -std=c11 -fPIC

# OS-specific bits
ifeq ($(OS),Windows_NT)
	$(error "Windows is not supported")
else ifeq ($(shell uname),Darwin)
	SOEXT = dylib
	SOEXTVER_MAJOR = $(SONAME_MAJOR).dylib
	SOEXTVER = $(SONAME_MAJOR).$(SONAME_MINOR).dylib
	LINKSHARED := $(LINKSHARED)-dynamiclib -Wl,
	ifneq ($(ADDITIONAL_LIBS),)
	LINKSHARED := $(LINKSHARED)$(ADDITIONAL_LIBS),
	endif
	LINKSHARED := $(LINKSHARED)-install_name,$(LIBDIR)/lib$(LANGUAGE_NAME).$(SONAME_MAJOR).dylib,-rpath,@executable_path/../Frameworks
else
	SOEXT = so
	SOEXTVER_MAJOR = so.$(SONAME_MAJOR)
	SOEXTVER = so.$(SONAME_MAJOR).$(SONAME_MINOR)
	LINKSHARED := $(LINKSHARED)-shared -Wl,
	ifneq ($(ADDITIONAL_LIBS),)
	LINKSHARED := $(LINKSHARED)$(ADDITIONAL_LIBS)
	endif
	LINKSHARED := $(LINKSHARED)-soname,lib$(LANGUAGE_NAME).so.$(SONAME_MAJOR)
endif
ifneq ($(filter $(shell uname),FreeBSD NetBSD DragonFly),)
	PCLIBDIR := $(PREFIX)/libdata/pkgconfig
endif

all: lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT) $(LANGUAGE_NAME).pc

lib$(LANGUAGE_NAME).a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

lib$(LANGUAGE_NAME).$(SOEXT): $(OBJS)
	$(CC) $(LDFLAGS) $(LINKSHARED) $^ $(LDLIBS) -o $@
ifneq ($(STRIP),)
	$(STRIP) $@
endif

$(LANGUAGE_NAME).pc: bindings/c/$(LANGUAGE_NAME).pc.in
	sed  -e 's|@URL@|$(PARSER_URL)|' \
		-e 's|@VERSION@|$(VERSION)|' \
		-e 's|@LIBDIR@|$(LIBDIR)|' \
		-e 's|@INCLUDEDIR@|$(INCLUDEDIR)|' \
		-e 's|@REQUIRES@|$(REQUIRES)|' \
		-e 's|@ADDITIONAL_LIBS@|$(ADDITIONAL_LIBS)|' \
		-e 's|=$(PREFIX)|=$${prefix}|' \
		-e 's|@PREFIX@|$(PREFIX)|' $< > $@

$(SRC_DIR)/parser.c: grammar.js
	$(TS) generate --no-bindings

install: all
	install -d '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter '$(DESTDIR)$(PCLIBDIR)' '$(DESTDIR)$(LIBDIR)'
	install -m644 bindings/c/$(LANGUAGE_NAME).h '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h
	install -m644 $(LANGUAGE_NAME).pc '$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc
	install -m644 lib$(LANGUAGE_NAME).a '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a
	install -m755 lib$(LANGUAGE_NAME).$(SOEXT) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT)

uninstall:
	$(RM) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT) \
		'$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h \
		'$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc

clean:
	$(RM) $(OBJS) $(LANGUAGE_NAME).pc lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT)

test:
	$(TS) test
	$(TS) parse examples/* --quiet --time

.PHONY: all install uninstall clean test

## tree-sitter-c 0.20.5

=== debian/changelog ===
tree-sitter-c (0.20.5-2) unstable; urgency=medium

  * Upload to unstable
  * Add explicit copyright stanza for debian/
  * Add comment about provenance of src/tree_sitter/parser.h

 -- James McCoy <jamessan@debian.org>  Thu, 25 Jan 2024 07:51:41 -0500

tree-sitter-c (0.20.5-1) experimental; urgency=medium

  * Initial debianization. (Closes: #1030088)

 -- James McCoy <jamessan@debian.org>  Wed, 27 Sep 2023 18:22:24 -0400

=== debian/control ===
Source: tree-sitter-c
Priority: optional
Maintainer: Tree-sitter Team <team+tree-sitter@tracker.debian.org>
Uploaders:
 James McCoy <jamessan@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 nodejs,
 tree-sitter-cli,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/tree-sitter/tree-sitter-c/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter-c.git
Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter-c

Package: tree-sitter-c-src
Architecture: all
Depends:
 ${misc:Depends},
 g++,
 libtree-sitter-dev,
 pkg-config,
Description: C parser for Tree-sitter (source files)
 This package contains the generated source files for building the C parser
 shared object.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export TREE_SITTER_SRC_DIR = /usr/src/tree-sitter/c/${DEB_VERSION_UPSTREAM}/

%:
	dh $@

debian/%: debian/%.in
	sed "s/@PARSER_VER@/$(DEB_VERSION_UPSTREAM)/g" $< > $@

override_dh_auto_build:
	tree-sitter generate --no-bindings

override_dh_install: debian/Makefile
	dh_install

override_dh_auto_test:
	XDG_CACHE_HOME=$(CURDIR)/debian/.cache tree-sitter test

=== debian/tests/control ===
Tests: smoke
Depends: tree-sitter-cli, tree-sitter-c-src

## tree-sitter-c 0.21.3

=== debian/changelog ===
tree-sitter-c (0.21.3-4) unstable; urgency=medium

  * Add libc-dev and make to tree-sitter-src Depends
  * Add cargo and rustc explicitly to Build-Depends

 -- James McCoy <jamessan@debian.org>  Sun, 16 Mar 2025 22:11:10 -0400

tree-sitter-c (0.21.3-3) unstable; urgency=medium

  * Upload to unstable
  * d/clean: Add trailing slash to debian/.cache/
  * Add librust-cc-dev to Build-Depends
  * Revert "Switch debian branch to debian/experimental"
  * Declare compliance with Policy 4.7.2, no changes needed

 -- James McCoy <jamessan@debian.org>  Sat, 08 Mar 2025 13:53:14 -0500

tree-sitter-c (0.21.3-2) experimental; urgency=medium

  * Fix typo in librust-tree-sitter-c-dev description
  * Add salsa-ci.yml config
  * salsa-ci: Use experimental release
  * Include array.h and alloc.h in tree-sitter-c-src

 -- James McCoy <jamessan@debian.org>  Sat, 21 Dec 2024 09:01:48 -0500

tree-sitter-c (0.21.3-1) experimental; urgency=medium

  * New upstream release (Closes: #1071623)
  * Add >= 0.22.6 version constraint on tree-sitter-cli Build-Depends
  * Include parser.h in the package to align with upstream change to not
    include parser.h in libtree-sitter-dev
  * Switch pkg-config Depends to pkgconf
  * Declare compliance with Policy 4.7.0, no changes needed
  * Adapt shared object build from C++ to C
  * Depend on libtree-sitter-dev >= 0.22
  * Add librust-tree-sitter-c-dev package

 -- James McCoy <jamessan@debian.org>  Tue, 17 Dec 2024 10:49:32 -0500

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,15 @@
 Uploaders:
  James McCoy <jamessan@debian.org>,
 Build-Depends:
+ cargo:native,
  debhelper-compat (= 13),
+ dh-sequence-rust,
  nodejs,
- tree-sitter-cli,
-Standards-Version: 4.6.2
+ librust-cc-1+default-dev (>= 1.0.90),
+ librust-tree-sitter-0+default-dev (>= 0.21),
+ rustc:native,
+ tree-sitter-cli (>= 0.22.6),
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/tree-sitter/tree-sitter-c/
 Rules-Requires-Root: no
@@ -18,9 +23,35 @@
 Architecture: all
 Depends:
  ${misc:Depends},
- g++,
- libtree-sitter-dev,
- pkg-config,
+ gcc,
+ libc6-dev | libc-dev,
+ libtree-sitter-dev (>= 0.22),
+ make,
+ pkgconf,
 Description: C parser for Tree-sitter (source files)
  This package contains the generated source files for building the C parser
  shared object.
+
+Package: librust-tree-sitter-c-dev
+Section: rust
+Architecture: any
+Multi-Arch: same
+Depends:
+ librust-cc-1+default-dev (>= 1.0.90),
+ librust-tree-sitter-0+default-dev (>= 0.21),
+ ${misc:Depends}
+Provides:
+ librust-tree-sitter-c+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.21+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.21-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.21.3+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.21.3-dev (= ${binary:Version}),
+Description: C grammar for the tree-sitter parser - Rust source code
+ tree-sitter-c is a tree-sitter grammar for C.
+ .
+ Tree-sitter is a parser generator and incremental parsing library.
+ .
+ This package contains the source for the Rust tree-sitter-c crate,
+ packaged for use with cargo.

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,14 @@
 
 override_dh_auto_build:
 	tree-sitter generate --no-bindings
+	dh_auto_build --buildsystem=rust
+
+override_dh_auto_install:
+	dh_auto_install --buildsystem=rust
 
 override_dh_install: debian/Makefile
 	dh_install
 
 override_dh_auto_test:
 	XDG_CACHE_HOME=$(CURDIR)/debian/.cache tree-sitter test
+	dh_auto_test --buildsystem=rust

=== debian/tests/control ===
Tests: smoke
Depends: tree-sitter-cli, tree-sitter-c-src

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.21.3 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-c-dev:@,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.0.90),
 librust-tree-sitter-0+default-dev (>= 0.21),
 librust-tree-sitter-c-0.21-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.21.3 --all-targets
Features:
 test-name=librust-tree-sitter-c-dev:default,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.0.90),
 librust-tree-sitter-0+default-dev (>= 0.21),
 librust-tree-sitter-c-0.21+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.21.3 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-c-dev:,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.0.90),
 librust-tree-sitter-0+default-dev (>= 0.21),
 librust-tree-sitter-c-0.21-dev,
Restrictions:
 allow-stderr,

## tree-sitter-c 0.24.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(tree-sitter-c
        VERSION "0.24.1"
        DESCRIPTION "C grammar for tree-sitter"
        HOMEPAGE_URL "https://github.com/tree-sitter/tree-sitter-c"
        LANGUAGES C)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(TREE_SITTER_REUSE_ALLOCATOR "Reuse the library allocator" OFF)

set(TREE_SITTER_ABI_VERSION 14 CACHE STRING "Tree-sitter ABI version")
if(NOT ${TREE_SITTER_ABI_VERSION} MATCHES "^[0-9]+$")
    unset(TREE_SITTER_ABI_VERSION CACHE)
    message(FATAL_ERROR "TREE_SITTER_ABI_VERSION must be an integer")
endif()

find_program(TREE_SITTER_CLI tree-sitter DOC "Tree-sitter CLI")

add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/src/parser.c"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/grammar.json"
                   COMMAND "${TREE_SITTER_CLI}" generate src/grammar.json
                            --abi=${TREE_SITTER_ABI_VERSION}
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                   COMMENT "Generating parser.c")

add_library(tree-sitter-c src/parser.c)
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/src/scanner.c)
  target_sources(tree-sitter-c PRIVATE src/scanner.c)
endif()
target_include_directories(tree-sitter-c
                           PRIVATE src
                           INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/bindings/c>
                                     $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)


target_compile_definitions(tree-sitter-c PRIVATE
                           $<$<BOOL:${TREE_SITTER_REUSE_ALLOCATOR}>:TREE_SITTER_REUSE_ALLOCATOR>
                           $<$<CONFIG:Debug>:TREE_SITTER_DEBUG>)

set_target_properties(tree-sitter-c
                      PROPERTIES
                      C_STANDARD 11
                      POSITION_INDEPENDENT_CODE ON
                      SOVERSION "${TREE_SITTER_ABI_VERSION}.${PROJECT_VERSION_MAJOR}"
                      DEFINE_SYMBOL "")

configure_file(bindings/c/tree-sitter-c.pc.in
               "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-c.pc" @ONLY)

include(GNUInstallDirs)

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bindings/c/tree_sitter"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
        FILES_MATCHING PATTERN "*.h")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-c.pc"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig")
install(TARGETS tree-sitter-c
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

add_custom_target(ts-test "${TREE_SITTER_CLI}" test
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  COMMENT "tree-sitter test")

=== Makefile ===
ifeq ($(OS),Windows_NT)
$(error Windows is not supported)
endif

LANGUAGE_NAME := tree-sitter-c
HOMEPAGE_URL := https://github.com/tree-sitter/tree-sitter-c
VERSION := 0.24.1

# repository
SRC_DIR := src

TS ?= tree-sitter

# install directory layout
PREFIX ?= /usr/local
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
PCLIBDIR ?= $(LIBDIR)/pkgconfig

# source/object files
PARSER := $(SRC_DIR)/parser.c
EXTRAS := $(filter-out $(PARSER),$(wildcard $(SRC_DIR)/*.c))
OBJS := $(patsubst %.c,%.o,$(PARSER) $(EXTRAS))

# flags
ARFLAGS ?= rcs
override CFLAGS += -I$(SRC_DIR) -std=c11 -fPIC

# ABI versioning
SONAME_MAJOR = $(shell sed -n 's/\#define LANGUAGE_VERSION //p' $(PARSER))
SONAME_MINOR = $(word 1,$(subst ., ,$(VERSION)))

# OS-specific bits
ifeq ($(shell uname),Darwin)
	SOEXT = dylib
	SOEXTVER_MAJOR = $(SONAME_MAJOR).$(SOEXT)
	SOEXTVER = $(SONAME_MAJOR).$(SONAME_MINOR).$(SOEXT)
	LINKSHARED = -dynamiclib -Wl,-install_name,$(LIBDIR)/lib$(LANGUAGE_NAME).$(SOEXTVER),-rpath,@executable_path/../Frameworks
else
	SOEXT = so
	SOEXTVER_MAJOR = $(SOEXT).$(SONAME_MAJOR)
	SOEXTVER = $(SOEXT).$(SONAME_MAJOR).$(SONAME_MINOR)
	LINKSHARED = -shared -Wl,-soname,lib$(LANGUAGE_NAME).$(SOEXTVER)
endif
ifneq ($(filter $(shell uname),FreeBSD NetBSD DragonFly),)
	PCLIBDIR := $(PREFIX)/libdata/pkgconfig
endif

all: lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT) $(LANGUAGE_NAME).pc

lib$(LANGUAGE_NAME).a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

lib$(LANGUAGE_NAME).$(SOEXT): $(OBJS)
	$(CC) $(LDFLAGS) $(LINKSHARED) $^ $(LDLIBS) -o $@
ifneq ($(STRIP),)
	$(STRIP) $@
endif

$(LANGUAGE_NAME).pc: bindings/c/$(LANGUAGE_NAME).pc.in
	sed -e 's|@PROJECT_VERSION@|$(VERSION)|' \
		-e 's|@CMAKE_INSTALL_LIBDIR@|$(LIBDIR:$(PREFIX)/%=%)|' \
		-e 's|@CMAKE_INSTALL_INCLUDEDIR@|$(INCLUDEDIR:$(PREFIX)/%=%)|' \
		-e 's|@PROJECT_DESCRIPTION@|$(DESCRIPTION)|' \
		-e 's|@PROJECT_HOMEPAGE_URL@|$(HOMEPAGE_URL)|' \
		-e 's|@CMAKE_INSTALL_PREFIX@|$(PREFIX)|' $< > $@

$(PARSER): $(SRC_DIR)/grammar.json
	$(TS) generate $^

install: all
	install -d '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter '$(DESTDIR)$(PCLIBDIR)' '$(DESTDIR)$(LIBDIR)'
	install -m644 bindings/c/tree_sitter/$(LANGUAGE_NAME).h '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h
	install -m644 $(LANGUAGE_NAME).pc '$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc
	install -m644 lib$(LANGUAGE_NAME).a '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a
	install -m755 lib$(LANGUAGE_NAME).$(SOEXT) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT)

uninstall:
	$(RM) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT) \
		'$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h \
		'$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc

clean:
	$(RM) $(OBJS) $(LANGUAGE_NAME).pc lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT)

test:
	$(TS) test

.PHONY: all install uninstall clean test

=== debian/changelog ===
tree-sitter-c (0.24.1-3) unstable; urgency=medium

  * Require tree-sitter-cli >= 0.25 for autopkgtest

 -- James McCoy <jamessan@debian.org>  Thu, 16 Oct 2025 08:27:49 -0400

tree-sitter-c (0.24.1-2) unstable; urgency=medium

  * Upload to unstable

 -- James McCoy <jamessan@debian.org>  Mon, 13 Oct 2025 20:43:08 -0400

tree-sitter-c (0.24.1-1) experimental; urgency=medium

  * New upstream release
  * Bump librust-tree-sitter-dev dependencies to 0.25
  * Generate parser using the same language ABI as upstream's release
  * d/rules: Remove "--no-bindings" from tree-sitter call

 -- James McCoy <jamessan@debian.org>  Mon, 01 Sep 2025 11:42:18 -0400

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,11 @@
  debhelper-compat (= 13),
  dh-sequence-rust,
  nodejs,
- librust-cc-1+default-dev (>= 1.0.90),
- librust-tree-sitter-0+default-dev (>= 0.21),
+ librust-cc-1+default-dev (>= 1.2),
+ librust-tree-sitter-language-0.1+default-dev,
+ librust-tree-sitter-0.25+default-dev (>= 0.25.4),
  rustc:native,
- tree-sitter-cli (>= 0.22.6),
+ tree-sitter-cli (>= 0.25.0),
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/tree-sitter/tree-sitter-c/
@@ -25,7 +26,7 @@
  ${misc:Depends},
  gcc,
  libc6-dev | libc-dev,
- libtree-sitter-dev (>= 0.22),
+ libtree-sitter-dev (>= 0.22.4),
  make,
  pkgconf,
 Description: C parser for Tree-sitter (source files)
@@ -37,17 +38,17 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- librust-cc-1+default-dev (>= 1.0.90),
- librust-tree-sitter-0+default-dev (>= 0.21),
+ librust-cc-1+default-dev (>= 1.2),
+ librust-tree-sitter-language-0.1+default-dev,
  ${misc:Depends}
 Provides:
  librust-tree-sitter-c+default-dev (= ${binary:Version}),
  librust-tree-sitter-c-0+default-dev (= ${binary:Version}),
  librust-tree-sitter-c-0-dev (= ${binary:Version}),
- librust-tree-sitter-c-0.21+default-dev (= ${binary:Version}),
- librust-tree-sitter-c-0.21-dev (= ${binary:Version}),
- librust-tree-sitter-c-0.21.3+default-dev (= ${binary:Version}),
- librust-tree-sitter-c-0.21.3-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.24+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.24-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.24.1+default-dev (= ${binary:Version}),
+ librust-tree-sitter-c-0.24.1-dev (= ${binary:Version}),
 Description: C grammar for the tree-sitter parser - Rust source code
  tree-sitter-c is a tree-sitter grammar for C.
  .

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	sed "s/@PARSER_VER@/$(DEB_VERSION_UPSTREAM)/g" $< > $@
 
 override_dh_auto_build:
-	tree-sitter generate --no-bindings
+	tree-sitter generate --abi $(shell sed -n 's/#define LANGUAGE_VERSION //p' src/parser.c)
 	dh_auto_build --buildsystem=rust
 
 override_dh_auto_install:

=== debian/tests/control ===
Tests: smoke
Depends: tree-sitter-cli (>= 0.25), tree-sitter-c-src

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.24.1 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-c-dev:@,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.2),
 librust-tree-sitter-0.25+default-dev (>= 0.25.4),
 librust-tree-sitter-c-0.24.1-dev,
 librust-tree-sitter-language-0.1+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.24.1 --all-targets
Features:
 test-name=librust-tree-sitter-c-dev:default,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.2),
 librust-tree-sitter-0.25+default-dev (>= 0.25.4),
 librust-tree-sitter-c-0.24.1+default-dev,
 librust-tree-sitter-language-0.1+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-c 0.24.1 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-c-dev:,
Depends:
 dh-rust,
 librust-cc-1+default-dev (>= 1.2),
 librust-tree-sitter-0.25+default-dev (>= 0.25.4),
 librust-tree-sitter-c-0.24.1-dev,
 librust-tree-sitter-language-0.1+default-dev,
Restrictions:
 allow-stderr,
